Attribute VB_Name = "modFlexUtilities"
Option Explicit
Option Compare Text

' The current sort order.
Public iSortCol As Integer
' The column selected for sorting.
Public iSortOrder As SortSettings


Public Declare Function QueryPerformanceCounter Lib "kernel32" _
    (lpPerformanceCount As Currency) As Long
    
Public Declare Function QueryPerformanceFrequency Lib "kernel32" _
    (lpFrequency As Currency) As Long

Public Enum MyFields
    FirstNameField = 0
    MiddleNameField
    LastNameField
End Enum

Public m_rsMain As ADODB.Recordset

Public Const MAX_NUM As Long = 10000

' Sort by the indicated column.
Public Function SortByColumn(mGrid As MSFlexGrid, iMouseCol As Integer, iMouseRow As Integer) As Boolean
If iMouseRow = 0 Then
    With mGrid
        ' Hide the FlexGrid.
        .Visible = False
        .Refresh

        ' Sort using the clicked column.
        .Col = iMouseCol
        .ColSel = iMouseCol
        .Row = 0
        .RowSel = 0

        ' If this is a new sort column, sort ascending.
        ' Otherwise switch which sort order we use.
        If iSortCol <> iMouseCol Then
            iSortOrder = flexSortGenericAscending
        ElseIf iSortOrder = flexSortGenericAscending Then
            iSortOrder = flexSortGenericDescending
        Else
            iSortOrder = flexSortGenericAscending
        End If
        .Sort = iSortOrder

        ' Restore the previous sort column's name.
        If iSortCol >= 0 Then
            If .TextMatrix(0, iSortCol) Like "<*" Or .TextMatrix(0, iSortCol) Like ">*" Then
                .TextMatrix(0, iSortCol) = Mid$(.TextMatrix(0, iSortCol), 3)
            End If
        End If
    
        ' Display the new sort column's name.
        iSortCol = iMouseCol
        If iSortOrder = flexSortGenericAscending Then
            .TextMatrix(0, iSortCol) = "> " & .TextMatrix(0, iSortCol)
        Else
            .TextMatrix(0, iSortCol) = "< " & .TextMatrix(0, iSortCol)
        End If
    
        ' Display the FlexGrid.
        .Visible = True
    End With
End If
End Function

Public Function KittuFillGrid(pGrid As MSFlexGrid, SQL As String, C As ADODB.Connection) As Boolean

'This function is used to fill the Ms Flex grid dynamically

Dim llngCount1 As Long
Dim llngCount2 As Long
Dim rs As New ADODB.Recordset
On Error GoTo ErrHndFillGrid

    rs.Open SQL, C, adOpenStatic, adLockReadOnly
    pGrid.Clear
     If rs.RecordCount <> 0 Then
        rs.MoveLast
        rs.MoveFirst
        pGrid.Cols = rs.Fields.Count + 1
        For llngCount1 = 0 To rs.Fields.Count - 1
             pGrid.Row = 0
             pGrid.Col = llngCount1 + 1
             pGrid.ColWidth(pGrid.Col) = 1200
             pGrid.Text = rs.Fields(llngCount1).Name
        Next llngCount1
        pGrid.Rows = rs.RecordCount + 1
        For llngCount1 = 0 To rs.RecordCount - 1
            pGrid.Row = llngCount1 + 1
            pGrid.Col = 0
            pGrid.Text = llngCount1 + 1
            For llngCount2 = 0 To rs.Fields.Count - 1
                pGrid.Col = llngCount2 + 1
                If rs(llngCount2).Type = adDate Then
                    pGrid.Text = Format(rs(llngCount2), "dd-mmm-yyyy")
                Else
                    pGrid.Text = Trim(rs(llngCount2)) & ""
                End If
            Next llngCount2
            rs.MoveNext
        Next llngCount1
        pGrid.TopRow = pGrid.Rows - 1
        KittuFillGrid = True
    Else
        KittuFillGrid = False
    End If
    rs.Close
    Set rs = Nothing
Exit Function
ErrHndFillGrid:

       KittuFillGrid = False

End Function

Public Function SunadhFillGrid(pGrid As MSFlexGrid, SQL As String, C As ADODB.Connection) As Boolean

'This function is used to fill the Ms Flex grid dynamically

Dim rs As New ADODB.Recordset, i As Integer, j As Integer, str As String
On Error GoTo ErrHndFillGrid

rs.Open SQL, C, adOpenStatic, adLockReadOnly

With pGrid
    .Clear: .FixedCols = 0: .FixedRows = 1: .Rows = 1: .Col = 1
    If Not (rs.EOF And rs.BOF) Then
        rs.MoveLast: rs.MoveFirst
        pGrid.Cols = rs.Fields.Count
        For i = 0 To rs.Fields.Count - 1
            .Col = i
            If rs.Fields(i).Type = 5 Then
                .ColAlignment(.Col) = 6
            Else
                .ColAlignment(.Col) = 2
            End If
            .ColWidth(.Col) = 1200
            .TextMatrix(0, i) = rs.Fields(i).Name
        Next i
        .Rows = rs.RecordCount + 1
        For i = 0 To rs.RecordCount - 1
            .Row = i + 1
                For j = 0 To rs.Fields.Count - 1
                    If rs.Fields(j).Type = adDate Then
                        str = Format(rs.Fields(j), "dd-mmm-yyyy")
                    ElseIf rs.Fields(j).Type = adBoolean Then
                        str = IIf(rs.Fields(j) = True, "Yes", "No")
                    Else
                        str = rs.Fields(j) & ""
                    End If
                    .TextMatrix(.Row, j) = str
                Next j
            rs.MoveNext
        Next i
        .TopRow = .Rows - 1
        SunadhFillGrid = True
    Else
        SunadhFillGrid = False
    End If
    End With
rs.Close
Set rs = Nothing
Exit Function
ErrHndFillGrid:

       SunadhFillGrid = False

End Function

Public Function FillGrid(mGrid As MSFlexGrid, SQL As String, Cn As ADODB.Connection) As Boolean
Dim rs As New ADODB.Recordset, i As Integer
On Error GoTo CONNECTIONERROR
On Error GoTo VBERROR
'Opening Record set
rs.Open SQL, Cn, adOpenStatic, adLockReadOnly, adCmdText

'Filling Column Headers
With mGrid
    .Clear: .FixedCols = 0: .FixedRows = 1: .Cols = rs.Fields.Count
    For i = 0 To rs.Fields.Count - 1
        .Col = i
        .ColWidth(.Col) = 1200
        If rs.Fields(i).Type = 5 Then
            .ColAlignment(.Col) = 6
        Else
            .ColAlignment(.Col) = 2
        End If
        .TextMatrix(0, i) = rs.Fields(i).Name
    Next i
End With

If Not (rs.EOF And rs.BOF) Then
    rs.MoveLast: rs.MoveFirst
    With mGrid
        .Col = 0: .Row = 1
        .Rows = IIf(rs.RecordCount = 1, 2, rs.RecordCount - 1)
        .RowSel = .Rows - 1
        .ColSel = .Cols - 1
        .Clip = rs.GetString(adClipString)
        .RowSel = 1: .ColSel = 0
        .Refresh
    End With
End If
If rs.State = 1 Then rs.Close
Set rs = Nothing
Exit Function
CONNECTIONERROR:
    showConnectionError Cn
    If rs.State = 1 Then rs.Close
    Set rs = Nothing
VBERROR:
    showVBError
    If rs.State = 1 Then rs.Close
    Set rs = Nothing
End Function

Public Sub showConnectionError(con As ADODB.Connection)
Dim errLoop As ADODB.Error, str As String
    For Each errLoop In con.Errors
        str = "Connection Error # " & errLoop.Number & vbCrLf & _
              "Source: " & errLoop.Source & vbCrLf & _
              "SQL State: " & errLoop.SQLState & vbCrLf & _
              "Native Error: " & errLoop.NativeError & vbCrLf & _
              "Description: " & errLoop.Description
        MsgBox str, vbCritical, "Connection Error"
    Next
End Sub

Public Sub showVBError()
Dim str As String
    If CBool(Err) Then
        str = "VB Error # " & Err.Number & vbCrLf & _
              "Source: " & Err.Source & vbCrLf & _
              "Description: " & Err.Description
        Err.Clear
        MsgBox str, vbCritical, "VB Runtime Error"
    End If
End Sub

Public Function searchGrid(mGrid As MSFlexGrid, SearchString As String) As Boolean
Dim sCol As Integer, sRow As Integer
With mGrid
    For sRow = 1 To .Rows - 1
        For sCol = 0 To .Cols - 1
            If LCase(.TextMatrix(sRow, sCol)) Like SearchString & "*" Then
                .Row = sRow: .RowSel = sRow: .Col = 0: .ColSel = .Cols - 1
                .TopRow = sRow
                Exit Function
            End If
        Next sCol
    Next sRow
End With
End Function

Public Function selectedRow(mGrid As MSFlexGrid, iMouseRow As Integer, C As ColorConstants) As Boolean
Dim i As Integer
Static lsRow As Integer
If iMouseRow > 0 Then
    With mGrid
        For i = 0 To .Cols - 1
            .Col = i
            .Row = iMouseRow
            .CellBackColor = C
            If lsRow > 0 And Not lsRow = iMouseRow Then
                .Row = lsRow
                .CellBackColor = .BackColor
            End If
        Next i
    End With
    lsRow = iMouseRow
End If
End Function

